---
title: WIP Programming in C++
subtitle: Introduction to Object Oriented Programming (OOP)
subsubtitle: Inheritance
layout: layouts/presentation.njk

required: classes,constructors,big-3

CoreCpp: https://isocpp.github.io/CppCoreGuidelines/CppCoreGuidelines#
GoogleCpp: https://google.github.io/styleguide/cppguide.html#
---

<section>
  <h2>Purpose of Inheritance</h2>

  <section>
    <h3>Which problems does a inheritance solve?</h3>
    <ul>
      <li>Sibling classes can share code that is defined in a common parent
        class
        &rArr; Implementation inheritance reduces code size
      </li>
      <li>Inheritance best models an is-a relationship.</li>
      <li></li>
    </ul>
  </section>

  <section>
    <h3>Which problems does a inheritance cause?</h3>
    <ul>
      <li>Multiple inheritance often imposes a higher performance overhead
      </li>
      <li>Multiple inheritance risks leading to ambiguity and confusion</li>
      <li></li>
    </ul>
    {#
    Do not overuse implementation inheritance. Composition is often more appropriate.
    https://google.github.io/styleguide/cppguide.html#Inheritance
    #}
  </section>
{#

#}
</section>

{#
start with simple (public) inheritance example; child has public functionality
of parent
#}

<section>
  <h2>Access Specifiers in C++ Inheritance</h2>
  public: If a derived class is declared in public mode, then the members of the base class are inherited by the derived class just as they are.

  private: In this case, all the members of the base class become private members in the derived class.

  Guidelines: only use public inheritance

  Limit the use of protected to those member functions that might need to be
  accessed from subclasses. Data members should be private.
  https://google.github.io/styleguide/cppguide.html#Inheritance
</section>


<section>
  <h2>Overriding Member Functions</h2>

  member functions in derived class override member function of base classes

</section>

<section>

{#
{% highlight "cpp" %}
{% include "source/cpp/templates/non_type_template.cpp" %}
{% endhighlight %}
{% include_code "source/cpp/templates/non_type_template.cpp" %}
#}

</section>

{#
interface inheritance (inheritance from a pure abstract base class
(one with no state or defined methods)) vs implementation inheritance
Interface inheritance can be used to programmatically enforce that a class
expose a particular API.

use final on classes when you don't intend to support using them as base classes
https://isocpp.github.io/CppCoreGuidelines/CppCoreGuidelines#c139-use-final-on-classes-sparingly

virtual functions
polymorphism

multiple inheritance?
#}


{% include 'slides/closing.njk' %}
